<template>
    <v-card>
        <v-card-title class="headline">{{ $t("mail")}}</v-card-title>
        <v-form ref="Mail">
            <v-card-text>
                <v-container>
                    <v-text-field 
                        v-model="mail" 
                        v-bind:label="$t('mail')" 
                        :rules="[rules.required, rules.adrMel]" 
                        @keyup.enter="submit" 
                        required
                    ></v-text-field>
                </v-container>
            </v-card-text>
            <v-card-actions>
                <v-btn color="normal" class="ma-2" @click="cancel">{{ $t("cancel") }}</v-btn>
                <v-spacer></v-spacer>
                <v-btn color="primary" class="ma-2" @click="submit">{{ $t("confirm") }}</v-btn>
            </v-card-actions>
        </v-form>
    </v-card>
</template>

<script>
    import APIUser from "@/api/UserAPI.js";

    const apiUser = new APIUser();

    export default {
        name: "Mail",

        data() {
            return {
                mail: "",
                rules: {
                    required: v => !!v || this.$t("required"),
                    adrMel: () =>  /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/gmi.test(this.mail) || this.$t("not-email"),
                },
            };
        },

        components: {

        },

        methods: {
            async submit() {
                try {
                    if(this.$refs.Mail.validate()) {
                        console.log("submit");
                        let data = await apiUser.forgottenPwd({
                            mail: this.mail,
                        });
                        console.log(data);
                        let id = data.data._id;
                        this.$refs.Mail.reset();
                        this.$emit("exit");
                        this.$router.push(`/forgottenPwd/${id}`);
                    }
                } catch (err) {
                    console.error(`Error has occured : ${err}`);
                }
            },
            cancel () {
                this.$refs.Mail.reset();
                this.$emit("exit");
            },

        },
    };
</script>

<i18n>
{
    "en": {
        "mail": "My mail"
    },
    "fr": {
        "mail": "Mon adresse mail"
    }
}
</i18n>

<style scoped>
    
</style>